# 集合
## Colletion
   * 集合和数组的对比
	   1. 集合长度是可变的；集合只能存储引用数据类型
	   2. 数组长度是固定的；数组既可以存储基本数据类型也可以存储引用数据类型
	* 集合的体系结构
		* Collection接口
			* List子接口
				* 特点：
					1. 有序（存和取顺序一致）
					2. 允许重复
					3. 有索引
				* List体系下常用集合：
					 1. ArrayList
					 2. LinkedList
					 3. Vector
			* Set子接口
				* 特点：
					1. 无序（存和取顺序不保证一致）
					2. 不允许重复
					3. 无索引
				* Set体系下常用集合：
					1. TreeSet
					2. HashSet
						1. LinkedHashSet
		* 集合学习目标：
			1. 会操作集合对象
			2. 理解不同集合的特点
		* 集合的学习方式：
			* 学习集合，学习最顶层（底层实现类必须实现顶层接口中的抽象方法）
			* 使用集合，使用最底层
	* Collection常用功能：
		* boolean add(E e) 添加元素,返回是否删除成功
		* void clear() 删除所有元素
		* boolean contains(Object o) 判断是否包含指定元素
		* boolean isEmpty() 判断是否为空，集合的长度为0
		* boolean remove(Object o) 删除指定元素，返回是否删除成功
		* int size()  获取长度（集合元素的个数）
		* Object[] toArray() 转换成数组
		* <T> T[]  toArray(T[] a) 给定指定类型的数组，将集合中的元素放入指定的数组中

		* Iterator<E> iterator() 获取遍历对应集合的迭代器对象

## 迭代器和增强for(foreach)
	* 迭代器:
		* Iterator： 对 collection体系集合进行遍历的迭代器
		* 获取迭代器对象：
				Iterator<泛型> iterator = 集合对象.iterator();
		
			范例：
			List<String> c = new ArrayList<>();
			Iterator<String> iterator = c.iterator();
			while (iterator.hasNext()) {
	            System.out.println(iterator.next());
	        }

	* 增强for循环:
		格式：
				for (数据类型 变量名 :  集合或者数组对象) {
    
                }

		执行流程：每次底层通过迭代器，取出集合或者数组的一个元素，然后赋值给前面的变量

## 泛型：
	* 概述：相当于一个可以接收具体类型的变量。当我们定义类、方法、接口的时候，可以不指定具体的类型，直到使用的时候才确定具体类型。
	* 泛型的好处：
        * 没有泛型容易产生的问题：
            取出元素使用的时候需要进行额外的类型转换
            容易引发类型转换异常

        * 有了泛型之后
            编译期就可以检查类型的不一致问题
            简化代码的书写，不需要过多的类型转换
	* 泛型的定义：
		* 泛型类
			* 创建类的对象，可以确定其泛型，作用域是整个类
		* 泛型方法
			* 调用此方法的时候，确定其泛型，作用域是方法中
		* 泛型接口
			1. 定义实现类的时候，指定接口泛型的具体类型
       		2. 定义实现类的时候不确定具体泛型的类型， 创建对象的时候，才指定接口的泛型
	* 泛型的通配符：
		* ?  			:代表使用的泛型可以是任意的数据类型   	ArrayList<?>
	    * ? extends E	:代表使用的泛型只能是E类型的子类/本身
	    * ? super E		:代表使用的泛型只能是E类型的父类/本身

## 斗地主案例：
	* 见上课代码
          